lab7/myimgur/accounts/urls.py
from django.urls import path
from . import views   #ovo from . znaci da targetiramo importanje iz trenutnog direktorija,
                      #u ovom slucaju iz views koji se nalazi u accounts direktoriju
                      
app_name = 'accounts'
urlpatterns = [
    path('sign-up', views.SignUpView.as_view(), name='signup'), #za views.SignUpView cemo unutar accounts views napraviti genericku klasu view koja ce odradivati sign up,
                                                                #ubiti koristit cemo djangovu sign up formu, ima samo username i password.
                                                                #napravit cemo template koji ce se renderirat u kojem ce bit forma, koju cemo staviti u template koji napravimo
                                                                #a SignupView cemo napraviti u views i reci mu koji je template koji koristimo
                                                                # ovaj .as_view() smo dodali na genericku klasu, kako bi se onda ona ponasala kao FUNKCIJSKI VIEW jer
                                                                # django po defaultu koristi funkcijski view
]

lab7/myimgur/app/urls.py
from django.urls import path

from . import views

app_name = 'app'
urlpatterns = [
    path('', views.index, name='index'),
    path('<int:image_id>/', views.detail, name='detail'),
    path('<int:image_id>/comment', views.comment, name='comment'),
    path('new', views.create_image, name="create_image"),  #ruta za kreiranje slika, path ce biti localhost8000/images/new
                                                           #otvorit ce html stranicu di ce bit forma
                                                           #sada moramo jos u views.py napravit akciju create image
]

lab7/myimgur/imgur/urls.py
#ovdje definiramo koje su glavne rute

from django.contrib import admin
from django.urls import include,path
from app import views

urlpatterns = [                             #zapamti, rute se slijedno testiraju, pa mozemo imati vise ruta i kada pronade match izlazi van
                                            #zato specificnije rute idu gore, a generalnije dolje. Zato se '' path stavlja na kraj
    path('admin/', admin.site.urls),
    path('accounts/', include('accounts.urls')),  #dodano iznad ovog reda sto je sad ispod, da prvo proba njeg naci
    path('accounts/', include('django.contrib.auth.urls')), #dodali da bi omogucili login i signup, 
                                                            #trebamo jos za ovo dodati novi direktorij u templates naziva registration
    path('images/', include('app.urls')),
    path('', views.index, name='index'), 
]

lab7/myimgur/accounts/models.py
from django.db import models

# Create your models here.

lab7/myimgur/app/models.py
from django.db import models
from django.utils import timezone

# Create your models here.
class TimeStamped(models.Model):
    created_at = models.DateTimeField(editable=False)
    updated_at = models.DateTimeField(editable=False)

    def save(self, *args, **kwargs):
        if not self.created_at:
            self.created_at = timezone.now()

        self.updated_at = timezone.now()
        return super(TimeStamped, self).save(*args, **kwargs)

    class Meta:
        abstract = True


class Image(TimeStamped):
    title = models.CharField(max_length=128, unique=True, blank=False)
    url = models.CharField(max_length=512)
    description = models.TextField(blank=True)
    pub_date = models.DateTimeField('Published at')
    upvotes = models.IntegerField(default=0)
    downvotes = models.IntegerField(default=0)

    def __str__(self):
        return self.title

    def comments_count(self):
        return image.comment_set.count()

    def votes(self):
        return self.upvotes - self.downvotes

class Comment(TimeStamped):
    image = models.ForeignKey(Image, on_delete=models.CASCADE)
    text = models.TextField(blank=False)
    author = models.CharField(max_length=256, blank=False)

    def __str__(self):
        return self.text[:80]

    


        

lab7/myimgur/app/forms.py
from .models import Image, Comment
from django.forms import ModelForm

class ImageForm(ModelForm):  #klasa ImageForm naslijeduje ModelForm, ModelForm moze formu izgenerirat iz instance, post requesta ili iz oboje
    class Meta:
        model=Image
        fields= ['title', 'url', 'description', 'pub_date']

lab7/myimgur/accounts/views.py
from django.shortcuts import render

# Create your views here.
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth.models import User
from django.urls import reverse_lazy
from django.views import generic

class SignUpView(generic.CreateView):  #klasa koju smo spemonuli u urls.py gdje tamo ona ima nakacen .as_view(),
                                       # SignUpView naslijeduje generic.CreateView klasu
                                       
    form_class = UserCreationForm      #generickoj CreateView klasi moramo reci koja form klasa ce se koristit
    success_url = reverse_lazy('login') #ako je uspjesno kreiran signup, on ga salje na navedeni url
    #!!! reverse_lazy koristimo uz class based view, a kada koristimo funkcijske vieowe koristimo obicni reverse
    
    template_name = 'registration/signup.html' #govori kako se zove template koji cemo renderirati (zove se registration/signup.html)
    #sada treba otici u base.html i dodati link na signup

lab7/myimgur/app/views.py
from django.shortcuts import render, get_object_or_404
from django.http import JsonResponse, HttpResponseRedirect
from django.urls import reverse
from .models import Image, Comment
from .forms import ImageForm

# Create your views here.

def index(request):
    images = Image.objects.order_by('-pub_date')
    context = { 'images': images}
    return render(request, 'app/index.html', context)

def detail(request, image_id):
    image = get_object_or_404(Image,pk=image_id)
    context = {'image': image, 
               'comments': image.comment_set.all(),
              }
    return render(request, 'app/detail.html', context)

def create_image(request):  #neide image id jer kada pravimo novu sliku ona jos nema id zapravo
    if request.method== 'POST': #uvijek zelimo odgovarati samo na POST metodu, zato sto zelimo samo submitat
        form = ImageForm(request.POST) #napravit cemo ImageForm formu bas za ovu metodu
                                       #formu cemo radit prema klasi Image iz models.py, stavit cemo ju u novi file forms.py
                                       
        if form.is_valid():
            saved_image=form.save()
            return HttpResponseRedirect(reverse('app:detail', args=(saved_image.id,))) 
    else:
        form= ImageForm()
    context = { 'form': form}
    return render(request, 'app/create_image.html', context)
def comment(request, image_id):
    image = get_object_or_404(Image, pk=image_id)
    try:
        comment = image.comment_set.create(
                   author=request.POST['author'],
                   text=request.POST['comment'],
                )
    except (KeyError, Comment.DoesNotExist):
        # Redisplay the comment posting form.
        return render(request, 'app/detail.html', {
            'image': image,
            'error_message': "Posting failed!",
        })
    else:
        # Always return an HttpResponseRedirect after successfully dealing
        # with POST data. This prevents data from being posted twice if a
        # user hits the Back button.
        return HttpResponseRedirect(reverse('app:detail', args=(image.id,)))

lab7/myimgur/app/templates/app/base.html
{% load static %}
<html>
  <head>
    <title>My Lame Imgur</title>


    <link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" crossorigin="anonymous" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" rel="stylesheet"/>
    <script src="https://code.jquery.com/jquery-3.2.1.min.js" crossorigin="anonymous" integrity="sha384-xBuQ/xzmlsLoJpyjoggmTEz8OWUFM0/RC5BsqQBDX2v5cMvDHcMakNTNrHIW2I5f"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" crossorigin="anonymous" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" crossorigin="anonymous" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl"></script>

    {% block extrahead %}
    {% endblock %}

    <link rel="stylesheet" href="{% static 'app/css/app.css' %}">
  </head>
  <body>
    <div class="page-header">
      <nav class="navbar navbar-expand-lg navbar-light bg-light">
        <a class="navbar-brand" href="/">My Lame Imgur</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbarSupportedContent">
          <ul class="navbar-nav mr-auto">
            <li class="nav-item active">
              <a class="nav-link" href="/">Home <span class="sr-only">(current)</span></a>
            </li>
          </ul>
          <ul class="navbar-nav ml-auto">
            {% if user.is_authenticated %} <!-- Uvjet gleda jesmo li ulogirani-->
              <li class="nav-item ">       <!-- Ako jesmo-->                          
                <a class="nav-link" href="#">Hi {{ user.username }}! </a> <!-- Ovo nam napise Hi admin ili usernam kad smo ulogirani-->
              </li>
              
              {% if user.is_superuser %}
                <li class="nav-item ">                                
                  <a class="nav-link" href="/admin">Admin dashboard</a> <!-- Ako je superuser, daje link na admin dashboard-->
               </li>
              {% endif %}
              <li class="nav-item ">                                
                <a class="nav-link" href="{% url 'logout'%}">Logout</a> <!-- Daje nam mogucnost za logout, bolje je rutu dinamicki dati({% url 'logout'%}), nego /accounts/logout-->
              </li>                                                     <!-- ovaj nacin je bolji u slucaju da se odlucimo mijenjati imena-->
            {% else %} <!-- Ako nismo ulogirani, onda stavi link na login-->
              <li class="nav-item ">
                <a class="nav-link" href="{% url 'login'%}">Login</a> <!--Link na login, bolje je rutu dinamicki dati({% url 'login'%}), nego /accounts/login -->
              </li>
              <li class="nav-item ">
                <a class="nav-link" href="{% url 'accounts:signup' %}">Signup</a> <!--Link na signup, dodao nakon sto sam kreirao accounts/urls.py i urlpattern za signup tamo -->
              </li>                                                               <!-- morao sam staviti da nam evaluira rutu pomocu django tagova, ne moze obicni path-->
            {% endif %}
          </ul>
        </div>
      </nav>

    </div>
    <div class="content container">
      <div class="row">
        <div class="col-md-12">
          <div class="jumbotron fluid-jumbotron">
            <div class="container">
              <h1 class="display-4">My Lame Imgur</h1>
              <p class="lead">Your one stop place for posting your lamest images!</p>
            </div>
          </div>
        </div>
      </div>
      <div class="row">
        <div class="col-md-12">
          {% block content %}
          {% endblock %}
        </div>
      </div>
    </div>
  </body>
</html>

lab7/myimgur/app/templates/app/create_image.html
{% extends 'app/base.html' %}

{% block content %}
<div class="row">
    <div class="col-md-12">
        <h2 class="text-center">Submit new image</h2>
    </div>
</div>

<form method="post" accept-charset="utf-8">
    {% csrf_token %}


    {% include 'includes/bs4_form.html' with form=form %}
<div class="row">
    <div class="col-md-8 mx-auto">
        <input type="submit" value="Create new image" class="btn btn-primary"> 
    </div>
</div>


</form>

{% endblock content %}

lab7/myimgur/app/templates/app/detail.html
{% extends 'app/base.html' %}

{% block extrahead %}


{% endblock extrahead %}


{% block content %}
<div class="container">
  <div class="row">
    <div class="col-md-6">
      <div class="date">
        {{ image.pub_date }}
      </div>
      <h2>{{ image.title }}</h2>
      <img class="app-fit" src="{{image.url}}" alt=""/>
    </div>
    <div class="col-md-6">
      <h3>Description</h3>
      <p>{{ image.description|linebreaksbr }}</p>
      <h3>Comments</h3>
      {% for comment in comments %}
        <div class="border comment">
          
          <p class="red">
            Author: {{ comment.author }} ({{comment.created_at}})
          </p>
          <p class="secondary">
            {{ comment.text }}
          </p>
        </div>
      {% endfor %}

      <h2>Post a comment</h2>
      {% if error_message %}<p><strong>{{ error_message }}</strong></p>{% endif %}

      <form action="{% url 'app:comment' image.id %}" method="post" class="border">
        {% csrf_token %}
        <p>
          <label for="comment_author">Author </label><br>
          <input type="text" name="author" id="comment_author" value="">
        </p>
        <p>
          <label for="comment_text">Comment </label><br>
          <textarea  name="comment" id="comment_text" rows="4" cols="50">
          </textarea>
        </p>

        <input type="submit" value="Vote">
      </form>
    </div>
  </div>
</div>
{% endblock %}

lab7/myimgur/app/templates/app/index.html
{% extends 'app/base.html' %}

{% block content %}
    <div class="row">
      <div class="col-md-10">
        <p><a href="{% url 'app:create_image' %}">Submit new image</a></p> <!--link na submit nove slike-->
      </div>
    </div>
    {% for image in images %}
      <div class="row">
        <div class="col-md-2">
          <img class="app-fit" src="{{image.url}}" alt=""/>
        </div>
        <div class="col-md-10">
          <div class="date">
            <p class="red">
            Score: {{ image.votes }}; Published: {{ image.pub_date }};  Comments: {{ image.comment_set.count }} 
            </p>
          </div>
          <h2><a href="{% url 'app:detail' image.id %}">{{ image.title }}</a></h2>
          <p>{{ image.description|linebreaksbr }}</p>
        </div>
      </div>
    {% endfor %}
{% endblock %}

lab7/myimgur/app/templates/includes/bs4_form.html
{% load widget_tweaks %}

{% for hidden_field in form.hidden_fields %}
    {{ hidden_field }}
  {% endfor %}

  {% if form.non_field_errors %}
    <div class="alert alert-danger" role="alert">
      {% for error in form.non_field_errors %}
        {{ error }}
      {% endfor %}
    </div>
  {% endif %}

  {% for field in form.visible_fields %}
    <div class="row form-group">
        <div class="col-md-8 controls mx-auto">
            {{ field.label_tag }}

            {% if form.is_bound %}
                {% if field.errors %}
                {% render_field field class="form-control is-invalid" %}
                {% for error in field.errors %}
                    <div class="invalid-feedback">
                    {{ error }}
                    </div>
                {% endfor %}
                {% else %}
                {% render_field field class="form-control is-valid" %}
                {% endif %}
            {% else %}
                {% render_field field class="form-control" %}
            {% endif %}

            {% if field.help_text %}
                <small class="form-text text-muted">{{ field.help_text }}</small>
            {% endif %}
        </div>
    </div>

{% endfor %}